/*
 * (C) COPYRIGHT 2009 CRZ
 *
 * File Name : hw_config.h
 * Author    : POOH
 * Version   : V1.0
 * Date      : 08/12/2009
 */

#ifndef __HW_CONFIG_H
#define __HW_CONFIG_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* includes */

#include "stm32l1xx.h"

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>

#include "debug.h"
#include "led.h"

#include "uart_comm.h"
#include "I2CRoutines.h"
#include "test_sensor_9axis.h"

#include "test_sensor_AL_BH17.h"
#include "test_sensor_HTU21.h"

#include "test_actuator.h"

/* global variables */

/* defines - common */

#define GPIO_USART_1_TX_PIN                    GPIO_Pin_9
#define GPIO_USART_1_TX_GPIO_PORT              GPIOA
#define GPIO_USART_1_TX_GPIO_CLK               RCC_AHBPeriph_GPIOA
#define GPIO_USART_1_TX_SOURCE                 GPIO_PinSource9
#define GPIO_USART_1_TX_AF                     GPIO_AF_USART1

#define GPIO_USART_1_RX_PIN                    GPIO_Pin_10
#define GPIO_USART_1_RX_GPIO_PORT              GPIOA
#define GPIO_USART_1_RX_GPIO_CLK               RCC_AHBPeriph_GPIOA
#define GPIO_USART_1_RX_SOURCE                 GPIO_PinSource10
#define GPIO_USART_1_RX_AF                     GPIO_AF_USART1

#define GPIO_USART_3_TX_PIN                    GPIO_Pin_10
#define GPIO_USART_3_TX_GPIO_PORT              GPIOC
#define GPIO_USART_3_TX_GPIO_CLK               RCC_AHBPeriph_GPIOC
#define GPIO_USART_3_TX_SOURCE                 GPIO_PinSource10
#define GPIO_USART_3_TX_AF                     GPIO_AF_USART3

#define GPIO_USART_3_RX_PIN                    GPIO_Pin_11
#define GPIO_USART_3_RX_GPIO_PORT              GPIOC
#define GPIO_USART_3_RX_GPIO_CLK               RCC_AHBPeriph_GPIOC
#define GPIO_USART_3_RX_SOURCE                 GPIO_PinSource11
#define GPIO_USART_3_RX_AF                     GPIO_AF_USART3

#define GPIO_I2C_1_SCL_PIN               GPIO_Pin_6
#define GPIO_I2C_1_SCL_GPIO_PORT         GPIOB
#define GPIO_I2C_1_SCL_GPIO_CLK          RCC_AHBPeriph_GPIOB
#define GPIO_I2C_1_SCL_SOURCE            GPIO_PinSource6
#define GPIO_I2C_1_SCL_AF                GPIO_AF_I2C1

#define GPIO_I2C_1_SDA_PIN               GPIO_Pin_7
#define GPIO_I2C_1_SDA_GPIO_PORT         GPIOB
#define GPIO_I2C_1_SDA_GPIO_CLK          RCC_AHBPeriph_GPIOB
#define GPIO_I2C_1_SDA_SOURCE            GPIO_PinSource7
#define GPIO_I2C_1_SDA_AF                GPIO_AF_I2C1

#define GPIO_I2C_2_SCL_PIN               GPIO_Pin_10
#define GPIO_I2C_2_SCL_GPIO_PORT         GPIOB
#define GPIO_I2C_2_SCL_GPIO_CLK          RCC_AHBPeriph_GPIOB
#define GPIO_I2C_2_SCL_SOURCE            GPIO_PinSource10
#define GPIO_I2C_2_SCL_AF                GPIO_AF_I2C2

#define GPIO_I2C_2_SDA_PIN               GPIO_Pin_11
#define GPIO_I2C_2_SDA_GPIO_PORT         GPIOB
#define GPIO_I2C_2_SDA_GPIO_CLK          RCC_AHBPeriph_GPIOB
#define GPIO_I2C_2_SDA_SOURCE            GPIO_PinSource11
#define GPIO_I2C_2_SDA_AF                GPIO_AF_I2C2

#define GPIO_LED_GPIO_PORT   GPIOC
#define GPIO_LED_1_PIN       GPIO_Pin_7
#define GPIO_LED_2_PIN       GPIO_Pin_8
#define GPIO_LED_3_PIN       GPIO_Pin_9

#define GPIO_BD_DETECT       GPIOC
#define GPIO_BD_DETECT_PIN   GPIO_Pin_2 /* PC2 */

#define GPIO_MCU_INT         GPIOH
#define GPIO_MCU_INT_PIN     GPIO_Pin_2 /* PH2 */

#define GPIO_MCU_MIO         GPIOB
#define GPIO_MCU_MIO_0_PIN   GPIO_Pin_12 /* PB12 */
#define GPIO_MCU_MIO_1_PIN   GPIO_Pin_13 /* PB13 */
#define GPIO_MCU_MIO_2_PIN   GPIO_Pin_14 /* PB14 */
#define GPIO_MCU_MIO_3_PIN   GPIO_Pin_15 /* PB15 */

#define GPIO_MCU_PA          GPIOA
#define GPIO_MCU_PA_0_PIN    GPIO_Pin_0 /* PA0 */
#define GPIO_MCU_PA_1_PIN    GPIO_Pin_1 /* PA1 */
#define GPIO_MCU_PA_2_PIN    GPIO_Pin_2 /* PA2 */
#define GPIO_MCU_PA_3_PIN    GPIO_Pin_3 /* PA3 */
#define GPIO_MCU_PA_4_PIN    GPIO_Pin_4 /* PA4 */
#define GPIO_MCU_PA_5_PIN    GPIO_Pin_5 /* PA5 */
#define GPIO_MCU_PA_6_PIN    GPIO_Pin_6 /* PA6 */
#define GPIO_MCU_PA_7_PIN    GPIO_Pin_7 /* PA7 */

/* functions */

void Set_USBClock(void);
void Enter_LowPowerMode(void);
void Leave_LowPowerMode(void);
void USB_Interrupts_Config(void);
void USB_Cable_Config (FunctionalState NewState);
void RCC_Configuration(void);
void NVIC_Configuration(void);
void GPIO_Configuration(void);
void EXTI_Configuration(void);

void USART1_Init_for_Debug(void);
void USART3_Init_for_Comm(void);

uint8_t USART_GetCharacter_Debug(void);

void LED_Test (void);
void KEY_Test (void);

void Delay(__IO uint32_t nTime);
void TimingDelay_Decrement(void);

void delay_1_second(void);
void delay_100_milli_second(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif  /*__HW_CONFIG_H */

